struct IconPixmap {
	int32 width;
	int32 height;
	uint8[] data;
}

struct ToolTip {
	string icon_title;
	IconPixmap[] icon_pixmap;
	string title;
	string text;
}

[DBus (name = "org.kde.StatusNotifierItem")]
interface StatusNotifierItem : Object {
	public const string OBJECT = "/StatusNotifierItem";

	// Properties
        public abstract string id { owned get; }
	public abstract string title { owned get; }
	public abstract string icon_name { owned get; }
	public abstract IconPixmap[] icon_pixmap { owned get; }
	public abstract ToolTip tool_tip { owned get; }
	public abstract ObjectPath menu { owned get; }

	// AppIndicator TODO: split in separate interface
	public abstract string icon_theme_path { owned get; }

	// Methods
	public abstract void activate(int x, int y);
	public abstract void context_menu(int x, int y);

	// Signals
	public abstract signal void new_icon();
	public abstract signal void new_tool_tip();
}
